import sys
import os
from io import StringIO  
from pprint import pprint
from datetime import datetime
clear = lambda: os.system('clear')

steden = """
Stad,Provincie,Aantal inwoners
Nijmegen,Gelderland,182000
Arnhem,Gelderland,176000
Groningen,Groningen,200000
"""

def usage():
  clear()
  
  print(f"""
  
  -----------------------------------------
  Usage: python3 {sys.argv[0]} {{list|dict|csv|at|loc|drop|type|query|dcol|drow|desc|head|tail|date|setup|oefen|antw}}
  -----------------------------------------
  """)
  exit(0)

if len(sys.argv) != 2:
  usage()

if sys.argv[1] != 'setup':
  import pandas as pd
  import numpy as np

if sys.argv[1] != 'setup':
  steden_file = StringIO(steden)
  df = pd.read_csv(steden_file)

if sys.argv[1] == 'list':
  clear()
  l = [['Nijmegen','Gelderland',182000],['Arnhem','Gelderland',176000],['Groningen','Groningen',200000]]
  print(f'Dataframe met list van lists:\n  l = [{l[0]},\n       {l[1]},\n       {l[2]}]')
  print('-----------------------------------------')
  df2 = pd.DataFrame(l, columns=['Stad', 'Provincie','Aantal inwoners'])
  print(f'df = pd.DataFrame(l, columns=["Stad", "Provincie","Aantal inwoners"]):\n{df2}')
  print('-----------------------------------------')
  df2.index = df2.index + 1
  print(f'df.index = df.index + 1:\n{df2}')
elif sys.argv[1] == 'dict':
  clear()
  data = {
    'Stad': ['Nijmegen','Arnhem','Groningen'],
    'Provincie': ['Gelderland','Gelderland','Groningen'],
    'Aantal inwoners': [182000,176000,200000]
  } 
  print('Dataframe met dict:')
  pprint(data,sort_dicts=False)
  print('-----------------------------------------')
  df3 = pd.DataFrame(data)
  print(f'df = pd.DataFrame(data):\n{df3}')
elif sys.argv[1] == 'csv':
  clear()
  print(f'df = pd.read_csv(steden_file):\n{df}')
  print('-----------------------------------------')
  print(f'df["Stad"]":\n{df["Stad"]}')
  print('-----------------------------------------')
  print(f'type(df["stad"]): {type(df["Stad"])}')
  print('-----------------------------------------')
  print(f'df["Stad"].to_string():\n{df["Stad"].to_string()}')
  print('-----------------------------------------')
  print(f'type(df["Stad"].to_string()):\n{type(df["Stad"].to_string())}')
  print('-----------------------------------------')
  print(f'df["Stad"].to_string(index=False):\n{df["Stad"].to_string(index=False)}')
  print('-----------------------------------------')
  print(f'df.keys():\n{df.keys()}')
  print('-----------------------------------------')
  print(f'df.columns():\n{df.columns}')
  print('-----------------------------------------')
  print(f'list(df.columns):\n{list(df.columns)}')
  print('-----------------------------------------')
  print(f'df.columns.values:\n{df.columns.values}')
  print('-----------------------------------------')
elif sys.argv[1] == 'at':
  clear()
  df.index = df.index + 1
  print(f'Dataframe:\n{df}')
  print('-----------------------------------------')
  print(f'df.at[1,"Stad"]:\n{df.at[1,"Stad"]}')
  print('-----------------------------------------')
  print(f'df.at[3,"Aantal inwoners"]:\n{df.at[3,"Aantal inwoners"]}')
elif sys.argv[1] == 'loc':
  clear()
  df.index = df.index + 1
  print(f'Dataframe:\n{df}')
  print('-----------------------------------------')
  print(f'df.loc[1,:]:\n{df.loc[1,:]}')
  print('-----------------------------------------')
  print(f'df.loc[[2,3],["Stad","Aantal inwoners"]]:\n{df.loc[[2,3],["Stad","Aantal inwoners"]]}')
  print('-----------------------------------------')
  print(f'df.loc[:,["Stad"]]:\n{df.loc[:,["Stad"]]}')
  print('-----------------------------------------')
  print(f'df.loc[:,:]:\n{df.loc[:,:]}')
  print('-----------------------------------------')
  print(f'df.loc[2,"Aantal inwoners"]:\n{df.loc[2,"Aantal inwoners"]}')
  print('-----------------------------------------')
  print(f'df.loc(1,"Stad"):\n{df.loc[1,"Stad"]}')
  print('-----------------------------------------')
  print(f'df.loc(2:3,"Stad":"Aantal inwoners"):\n{df.loc[2:3,"Stad":"Aantal inwoners"]}')
  print('-----------------------------------------')
  print(f'Type df.loc[2:3,"Stad":"Aantal inwoners"]:\n{type(df.loc[2:3,"Stad":"Aantal inwoners"])}')
  print('-----------------------------------------')
  print(f'["Stad","Aantal inwoners"]:\n{df.loc[2:3,"Stad":"Aantal inwoners"]}')
  print('-----------------------------------------')
  print(f'df.loc(:,"Stad"):\n{df.loc[:,"Stad"]}')
elif sys.argv[1] == 'drop':
  clear()
  print(f'df3.drop("Stad",axis=1):\n{df3.drop("Stad", axis=1)}')
elif sys.argv[1] == 'type':
  clear()
  df4 = df3.astype({'Aantal inwoners':'int'})
  print(f'df3.astype({{"Aantal inwoners":"int"}}:\n{df4.dtypes}')
elif sys.argv[1] == 'query':
  clear()
  print(f'Dataframe:\n{df}')
  print('-----------------------------------------')
  print(f'df.dtypes:\n{df.dtypes}')
  print('-----------------------------------------')
  #print(f'df2 = df.astype({{"Aantal inwoners":"int"}}')
  print(f'df.query("`Aantal inwoners` > 150000 and `Aantal inwoners` < 200000"):\n{df.query("`Aantal inwoners` > 150000 and `Aantal inwoners` < 200000")}')
  print('-----------------------------------------')
  print(f'df.query("`Aantal inwoners` > 150000 and `Aantal inwoners` < 200000").sort_values("Aantal inwoners"):\n{df.query("`Aantal inwoners` > 150000 and `Aantal inwoners` < 200000").sort_values("Aantal inwoners")}')
elif sys.argv[1] == 'dcol':
  clear()
  print(f'Dataframe:\n{df}')
  print('-----------------------------------------')
  print(f'df.drop(columns="Provincie"):\n{df.drop(columns="Provincie")}')
  print('-----------------------------------------')
  print(f'df.drop(columns=df.loc[:,"Provincie":"Aantal inwoners"]):\n{df.drop(columns=df.loc[:,"Provincie":"Aantal inwoners"])}')
elif sys.argv[1] == 'drow':
  clear()
  print(f'Dataframe:\n{df}')
  print('-----------------------------------------')
  print(f'df.drop(df.index[2:]):\n{df.drop(df.index[2:])}')
elif sys.argv[1] == 'desc':
  clear()
  print(f'df.describe():\n{df.describe()}')
elif sys.argv[1] == 'head':
  clear()
  print(f'df.head(2):\n{df.head(2)}')
elif sys.argv[1] == 'tail':
  clear()
  print(f'df.tail(2):\n{df.tail(2)}')
elif sys.argv[1] == 'date':
  clear()
  date_series = pd.date_range(datetime(2023, 10, 10, hour=0, minute=0), periods=268, freq='5min')
  print(f'date_series = pd.date_range(datetime(2023, 10, 10, hour=0, minute=0), periods=268, freq="5min"):\n{date_series}')
  num_series = np.random.randint(100, size=268)
  print(f'np.random.randint(100, size=268):\n{num_series}')
  date_df = pd.DataFrame({'datetime':pd.to_datetime(date_series),'values':num_series})
  print(f'pd.DataFrame({{"datetime":pd.to_datetime(date_series),"values":num_series}}:\n{date_df}')
  date_df.set_index('datetime',inplace=True)  
  print(f'date_df.set_index("datetime",inplace=True):\n{date_df}')
  average = date_df.resample('M').mean()
  print(f'Month average: (date_df.resample("M").mean()):\n{average}')
  print('-----------------------------------------')
elif sys.argv[1] == 'setup':
  clear()
  setup_venv = f"""
  -----------------------------------------
  We gaan werken in een virtual environment: zo wordt je systeem niet vervuild.

  Maak deze python virtual environment als volgt (voor python 3.5+):
    $ python3 -m venv "jouw_venv_naam"
  Activeer de virtual environment:
    $ source "jouw_venv_naam"/bin/activate
  Start de python3 interpreter met:
    ("jouw_venv_naam") $ python3
    >>>
    Geen pandas? (check bv. met "import pandas as pd"):
    Geen numpy? (check bv. met "import numpy as np"):
  Installeer pandas en numpy (indien nodig) in je virtual environment:
     >>> ^D
     ("jouw_venv_naam") $ pip install pandas
     ("jouw_venv_naam") $ pip install numpy
  Start de python3 interpreter weer met:
    ("jouw_venv_naam") $ python3
  Importeer nu pandas en numpy:
     >>> import pandas as pd
     >>> import numpy as np 

  Werk vanaf nu in deze virtual environment

  Verlaten van de virtual environment:
    >>> ^D
    ("jouw_venv_naam") $ deactivate  
  Merk op: als je de python3 interpreter verlaat moet je pandas en evt. andere modules opnieuw importeren.
  -----------------------------------------
  """
  print(setup_venv)
elif sys.argv[1] == 'oefen':
  oef1 = f"""
  -----------------------------------------
  Oefening 1:
  Geef de volgende commando's:
    ("jouw_venv_naam") $ python3
    >>> import pandas as pd
    >>> import numpy as np
    >>> df = pd.DataFrame(np.random.randint(100, size=100).reshape(-1, 5), columns=['A', 'B', 'C','D','E'])

  1a) Toon dit Dataframe
  1b) Toon de maximale waarde voor kolom 'B'
  1c) Toon de gemiddelde waarde voor kolom 'C'
  1d) Maak een nieuwe column met de naam 'Gemiddelde' met de gemiddelde waarde per rij
  1e) Een uitdaging: maak een nieuwe *rij* met de de gemiddelde waarde per *kolom*
                     Hint: met "df.mean(axis=0)" krijg je een Pandas Serie met de gemiddelden per kolom.
                     Denk dan aan het omwisselen ('transpose') van index en columns..
                     Gebruik voor het toevoegen van de rij pd.concat(...)
  1f) Geef het gemiddelde van alle waarden in df
      Hint: gebruik numpy's mean (of "nanmean") functie
      Bonus: komt deze waarde terug ergens in het resultaat van 1e?
  -----------------------------------------
  """
  print(oef1)

  oef2 = f"""
  -----------------------------------------
  Oefening 2:
  2a) Gebruik de volgende dict:
       inwoners = {{
         'Land': ['Nederland','Belgie','Frankrijk','Duitsland','Spanje'],
         'Aantal inwoners': [17800800,12300000,64600000,81900000,41200000]
       }} 
     om een dataframe te maken.
     Hint: zie 'python3 {sys.argv[0]} dict'
  2b) Toon het gemiddelde aantal inwoners voor de 5 landen
  2c) Lastig: Toon het land met de meeste inwoners
             Hint: gebruik de df.max() functie voor de column: df['Aantal inwoners']
             Hint: gebruik ook de df.query() functie (zie ook 'python3 {sys.argv[0]} query') met deze max waarde
  -----------------------------------------
  """
  print(oef2)

  oef3 = f"""
  -----------------------------------------
  Oefening 3:
  3a) Maak een Dataframe met datetime als index, voor alle dagen van september 2023, met stappen van een uur (dus 30 x 24 (=720)) rows
      Maak ook een Serie van 720 random column waarden
      Hint: je hebt de datetime module nodig:
        >>> from datetime import datetime
      Hint: zie 'python3 {sys.argv[0]} date'
  3b) Beetje lastig: Toon het gemiddelde per dag
      Maar gebruik de hint: zie ook 'python3 {sys.argv[0]} date | less -r'
  -----------------------------------------
  """
  print(oef3)
elif sys.argv[1] == 'antw':
  clear()
  antw1 = f"""
  -----------------------------------------
  1a) >>> df
  1b) >>> df['B'].max()
  1c) >>> df['C'].mean()
  1d) >>> df['Gemiddelde'] = df.mean(axis=1)
  1e) >>> pd.concat([df, df.mean(axis=0).to_frame().T], ignore_index=True) # .T (transpose) verwisseld index en column
  1f) >>> np.mean(df)
  Deze waarde komt terug in de waarde rechtsonder bij 2e: "het gemiddelde van het gemiddelde"
  -----------------------------------------
  """
  print(antw1)

  antw2 = f"""
  -----------------------------------------
  2a) >>> inwoners = {{
            'Land': ['Nederland','Belgie','Frankrijk','Duitsland','Spanje'],
            'Aantal inwoners': [17800800,12300000,64600000,81900000,41200000]
          }} 
      >>> df_inwoners = pd.DataFrame(inwoners)

  2b) >>> df_inwoners["Aantal inwoners"].mean()

  2c) >>> df_inwoners.query(f"`Aantal inwoners` == {{df_inwoners['Aantal inwoners'].max()}}")
  -----------------------------------------
  """
  print(antw2)

  antw3 = f"""  
  -----------------------------------------
  3a)
  Maak eerst 2 series:
    >>> sep_series = pd.date_range(datetime(2023, 9, 1, hour=0, minute=0), periods=720, freq="H")
    >>> sep_num_series = np.random.randint(100, size=720)
  Maak je dataframe van beide series:
    >>> sep_df = pd.DataFrame({{'datetime':pd.to_datetime(sep_series),'values':sep_num_series}})
  Vevang de index door de 'datetime' column:
    >>> sep_df.set_index('datetime',inplace=True)  

  3b)
  Gebruik de resample functie met argument 'D' (Day):
    >> sep_df.resample('D').mean()

  Toon:
  >>> sep_average
  -----------------------------------------
  """
  print(antw3)
